//
// ifmbm.cpp
//

#include "stdafx.h"
#include "ifmbm.h"

#define __OUTPUT_SLOG

#include "bmconv_s60/src/BMCONV.H"

static const char *pluginfo[] = {
	"00AM",					/* Plug-in APIo[W */
	"mbm extract library ver0.001 (c)m.takemi",
	"*.mbm",
	"MBM(Multi BitMap)",
};

BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

int SUSIE_API GetPluginInfo(int infono, LPSTR buf, int buflen)
{	if (infono < 0 || infono >= (sizeof(pluginfo) / sizeof(char *))) 
		return 0;

	lstrcpyn(buf, pluginfo[infono], buflen);

	return lstrlen(buf);
}

int SUSIE_API IsSupported(LPSTR filename, DWORD dw)
{
	// ͂̏ꍇ́Afilename̎Ԃ݂͑Ȃ.
	// JȂT|[gɂ
	//  ƎvǁAfilename̓tpXȂBB
//	HANDLE hf = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
//	if(hf == INVALID_HANDLE_VALUE) return 0;
//	CloseHandle(hf);

	// Ƃ肠gqŁB
#define MBM_EXTENSION_LENGTH 4
#define MBM_EXTENSION ".mbm"
	int len = lstrlen(filename);
	if(len > MBM_EXTENSION_LENGTH){
		char *p = (filename + len) - MBM_EXTENSION_LENGTH;
		if(!lstrcmpi(p, MBM_EXTENSION)){
			return 1;
		}
	}
	return 0;
}

const char *GetMethod(int compression)
{
	switch (compression)
	{
	  case ENoBitmapCompression:
		return "no";
		break;
	  case EByteRLECompression:
	  case ETwelveBitRLECompression:
	  case ESixteenBitRLECompression:
	  case ETwentyFourBitRLECompression:
	  case EThirtyTwoUBitRLECompression:
	  case EThirtyTwoABitRLECompression:
		return "-RLE-";
		break;
	  default:
		break;
	}
	return "no";
}

#include <sys/types.h>
#include <sys/stat.h>

int SUSIE_API GetArchiveInfo(LPSTR buf, long len, unsigned int flag, HLOCAL *lphInf)
{
	// ͂ɂ͑ΉȂ
	// łAŃG[ԂƉُ̂ÎŁA
	// (0xC015000F: ANeBuĂANeBuReLXǵAŋ߃ANeBuꂽ̂ł͂܂B)
	if ((flag & SPI_SRC_MASK) != 0){
		*lphInf = LocalAlloc(LPTR, sizeof(fileInfo) * 2);

		fileInfo *pinfo = (fileInfo *)*lphInf;
		memset((char*)pinfo, 0, sizeof(fileInfo));
		lstrcpy((char*)pinfo->method, "no");
		lstrcpy((char*)pinfo->filename, "͖͂T|[g");

		++pinfo;
		pinfo->method[0] = '\0';

		return SPI_ALL_RIGHT;
	}

	// t@CXV擾.
	struct stat st;
	stat(buf, &st);

	EpocLoader el;
	int count, format;
	int ret = el.EpocBitmapCount(buf, count, format);
	if(ret || !count){
		return SPI_OTHER_ERROR;
	}

	*lphInf = LocalAlloc(LPTR, sizeof(fileInfo) * (count + 1));
	if (!*lphInf) {
		return SPI_NO_MEMORY;
	}

	fileInfo *pinfo = (fileInfo *)*lphInf;
	for(int n1 = 0; n1 < count; ++n1){
		ret = el.LoadEpocBitmap(buf, n1);

		if(!ret){
			SEpocBitmapHeader header = el.Header();

			lstrcpy((char*)pinfo->method, GetMethod(header.iCompression));
			lstrcpy(pinfo->path, "");
			pinfo->position = n1;
			pinfo->timestamp = st.st_mtime;

			pinfo->compsize = header.iBitmapSize;

			//		int byteSize = BitmapUtils::ByteWidth(header.iWidthInPixels, header.iBitsPerPixel) * header.iHeightInPixels;
			int byteSize = (header.iHeightInPixels * (((header.iWidthInPixels * 3) + 3) & ~3))
				+ sizeof(TBitmapFileHeader) + sizeof(TBitmapInfoHeader);

			pinfo->filesize = byteSize;

			char buf[16] = "";
			wsprintf(buf, "%d.bmp", n1);
			lstrcpy(pinfo->filename, buf);
		}
		++pinfo;
	}
	pinfo->method[0] = '\0';

	return SPI_ALL_RIGHT;
}

int SUSIE_API GetFileInfo(LPSTR buf, long len, LPSTR filename, unsigned int flag, struct fileInfo *lpInfo)
{
	//͂ɂ͑ΉȂ
	if ((flag & SPI_SRC_MASK) != 0) return SPI_NO_FUNCTION;

	struct stat st;
	stat(buf, &st);

	int index = atoi(filename);

	if(index != len) len = index;

	EpocLoader el;
	int ret = el.LoadEpocBitmap(buf, len);
	if(!ret){
		SEpocBitmapHeader header = el.Header();

		lstrcpy((char*)lpInfo->method, GetMethod(header.iCompression));
		lstrcpy(lpInfo->path, "");
		lpInfo->position = len;
		lpInfo->timestamp = st.st_mtime;

		lpInfo->compsize = header.iBitmapSize;

		//		int byteSize = BitmapUtils::ByteWidth(header.iWidthInPixels, header.iBitsPerPixel) * header.iHeightInPixels;
		int byteSize = (header.iHeightInPixels * (((header.iWidthInPixels * 3) + 3) & ~3))
			+ sizeof(TBitmapFileHeader) + sizeof(TBitmapInfoHeader);

		lpInfo->filesize = byteSize;

		char buf[16] = "";
		wsprintf(buf, "%d.bmp", len);
		lstrcpy(lpInfo->filename, buf);
		return SPI_ALL_RIGHT;
	}

	return SPI_OTHER_ERROR;
}

int SUSIE_API GetFile(LPSTR src, long len,
			   LPSTR dest, unsigned int flag,
			   SPI_PROGRESS lpPrgressCallback, long lData)
{
	//t@Cւ̏o͂͑ΉĂȂ
	if ((flag & SPI_DST_MASK) == 0) return SPI_NO_FUNCTION;
	//͂ɂ͑ΉȂ
	if ((flag & SPI_SRC_MASK) != 0) return SPI_NO_FUNCTION;

	if((*lpPrgressCallback)(0, 2, lData)) return SPI_ABORT;

	EpocLoader el;
	int ret = el.LoadEpocBitmap(src, len);

	if((*lpPrgressCallback)(1, 2, lData)) return SPI_ABORT;

	if(!ret){
		const SEpocBitmapHeader *header = el.LoadedHeader();
		HLOCAL *pLocal = (HLOCAL*)dest;
		int datasize = (header->iHeightInPixels * (((header->iWidthInPixels * 3) + 3) & ~3))
							 + sizeof(TBitmapFileHeader) + sizeof(TBitmapInfoHeader);
		*pLocal = LocalAlloc(LPTR, datasize);
		el.SaveBitmapToBuffer((char *)*pLocal);

		if((*lpPrgressCallback)(2, 2, lData)) return SPI_ABORT;

		return SPI_ALL_RIGHT;
	}

	return SPI_OTHER_ERROR;
}


